﻿using System;
using System.Diagnostics;
using System.Collections.Generic;

namespace X03
{
	public class Global : System.Web.HttpApplication
	{
		public static new System.Web.HttpRequest Request;
		public static string Out = "";

		public static Dictionary<Type, Dictionary<string, object>> Data = new Dictionary<Type, Dictionary<string, object>>();
		public static void ClearData()
		{
			Data = new Dictionary<Type, Dictionary<string, object>>();
		}
		public static object SetData(Type key1, string key2, object value)
		{
			if (!Data.ContainsKey(key1))
			{
				Data.Add(key1, new Dictionary<string, object>());
				Data[key1]["ver"] = null;	// Data schema version
			}
			Data[key1][key2] = value;
			return value;
		}
		public static object GetData(Type key1, string key2)
		{
			return (Data.ContainsKey(key1) && Data[key1].ContainsKey(key2)) ? Data[key1][key2] : null;
		}
		public static Dictionary<string, object> GetDataSet(Type key1)
		{
			return Data.ContainsKey(key1) ? Data[key1] : null;
		}

		protected void Application_Start(object sender, EventArgs e)
		{
			Debug.WriteLine("Application_Start");
		}

		protected void Session_Start(object sender, EventArgs e)
		{

		}

		protected void Application_BeginRequest(object sender, EventArgs e)
		{

		}

		protected void Application_AuthenticateRequest(object sender, EventArgs e)
		{
			Global.Out = "";
			Global.Request = System.Web.HttpContext.Current.Request;
		}

		protected void Application_Error(object sender, EventArgs e)
		{

		}

		protected void Session_End(object sender, EventArgs e)
		{

		}

		protected void Application_End(object sender, EventArgs e)
		{

		}
	}
}