﻿
namespace X03.PageElementVisitors
{
	public class WikitextCollector : PageElementVisitor
	{
		public string Collection { get; protected set; }

		public override void Visit(PageElement element)
		{
			this.Collection += element.WikitextPre;

			foreach (var child in element.Children)
			{
				child.Accept(this);
			}

			this.Collection += element.WikitextPost;
		}

		public WikitextCollector()
		{
			this.Collection = "";
		}
	}
}
