﻿using System;
using System.Collections.Generic;
using System.Text.RegularExpressions;

namespace X03.PageElements.Notations
{
	public class Ls : PageElements.Notation, Plugin.PageElement, Plugin.Findable
	{
		override public void Accept(PageElementVisitor visitor)
		{
			visitor.Visit(this);
		}

		public string[] ToPageSet()
		{
			var pageSet = new List<string>();

			//UNDONE:すべてのページを用意。
			pageSet.Add("Target01");
			pageSet.Add("Target02");
			pageSet.Add("Target03");
			pageSet.Add("Target04");
			pageSet.Add("Target05");
			pageSet.Add("Target06");
			pageSet.Add("Target07");
			pageSet.Add("Target08");

			return pageSet.ToArray();
		}

		public string ToWikitext()
		{
			return this.Wikitext;
		}

		public string ToHtml()
		{
			return "";
		}

		public string ToPlaintext()
		{
			return "";
		}

		public override void InAction()
		{
			foreach (var child in this.Children)
				child.InAction();
		}

		public override string CreateTag()
		{
			return this.GetType().Name + ":" + "";
		}

		public float SimilarityTo2(PageElement that)
		{
			return 1F;
		}

		static public new string Pattern
		{
			get { return @"&amp;ls;"; }
		}

		public Ls(PageElement parent, Match m, HashSet<Type> ignoreClasses)
			: base(parent, m, ignoreClasses)
		{
			this.WikitextPre = m.Groups[0].Value;
			//string content = m.Groups[1].Value;

			//ignoreClasses.Add(this.GetType());
			//this.Children.AddRange(PageElements.Notation.Tokenize(content, ignoreClasses));
			//ignoreClasses.Remove(this.GetType());
		}
	}
}
